unit UUser; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, UDatabase, USqlDatabase, UCore;

type

  { TUser }

  TUser = class
    Id: Integer;
    SubjectName: string;
    FirstName: string;
    SecondName: string;
    Email: string;
    PhoneNumber: string;
    Password: string;
    UserName: string;
    Town: string;
    Street: string;
    PSC: string;
    IC: Integer;
    DIC: string;
    procedure LoadFromDbRecord(DbRow: TAssocArray);
    procedure Store;
  end;

  { TUserList }

  TUserList = class(TDbList)
    procedure NewRegistration(UserName, Password, Email: string);
    procedure Login(UserName, Password: string);
  end;

implementation

{ TUser }

procedure TUser.LoadFromDbRecord(DbRow: TAssocArray);
begin
  Id := StrToInt(DbRow.Values['id']);
  FirstName := DbRow.Values['first_name'];
  SecondName := DbRow.Values['second_name'];
  Email := DbRow.Values['email'];
  PhoneNumber := DbRow.Values['phone'];
  UserName := DbRow.Values['nick'];
  Password := DbRow.Values['password'];
end;

procedure TUser.Store;
var
  Values: TAssocArray;
begin
  Values := TAssocArray.Create;
  Values.AddKeyValue('second_name', SecondName);
  Values.AddKeyValue('first_name', FirstName);
  Values.AddKeyValue('email', Email);
  Values.AddKeyValue('nick', UserName);
  Values.AddKeyValue('password', Password);
  Values.AddKeyValue('phone', PhoneNumber);
  Database.Update('users', Values, 'id=' + IntToStr(Id));
  Values.Free;
  inherited;
end;

{ TUserList }

procedure TUserList.NewRegistration(UserName, Password, Email: string);
begin

end;

procedure TUserList.Login(UserName, Password: string);
begin

end;

end.

